KToolBar class Reference (kdeui Library)

| # kdeui Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KToolBar Class Reference

A KDE-style toolbar. Floatable toolbar with auto resize. More...

`#include <ktoolbar.h>`

Inheritance diagram for KToolBar:

[legend]
Collaboration diagram for KToolBar:

[legend]
List of all members.

## Public Types
enum | IconText { IconOnly = 0, IconTextRight, TextOnly, IconTextBottom }
enum | BarStatus { Toggle, Show, Hide }
| The state of the status bar. More...
enum | BarPosition { Unmanaged, Floating, Top, Bottom, Right, Left, Flat }
| Possible bar positions. More...
## Public Slots
virtual void | setIconText (const QString &txt)
## Signals
void | clicked (int id)
| Emitted when button `id` is clicked.
void | doubleClicked (int id)
| Emitted when button `id` is double-clicked.
void | pressed (int)
| Emitted when button `id` is pressed.
void | released (int)
| Emits when button `id` is released.
void | toggled (int)
| Emitted when a toggle button changes state.
void | highlighted (int id, bool isHighlighted)
| This signal is emitted when item id gets highlighted/unhighlighted (i.e when mouse enters/exits).
void | highlighted (int id)
| This signal is emitted when item id gets highlighted/unhighlighted (i.e when mouse enters/exits).
void | moved (BarPosition)
| Emitted when toolbar changes position, or when an item is removed from toolbar.
void | modechange ()
void | toolbarDestroyed ()
| This signal is emitted when the toolbar is getting deleted, and before ~KToolbar finishes (so it's still time to remove widgets from the toolbar).
## Public Member Functions
| KToolBar (QWidget *parent, const char *name=0, bool honor_style=FALSE, bool readConfig=TRUE)
| Constructor.
| KToolBar (QMainWindow *parentWindow, QMainWindow::ToolBarDock dock, bool newLine=false, const char *name=0, bool honor_style=FALSE, bool readConfig=TRUE)
| Constructor for non-XML-GUI applications.
| KToolBar (QMainWindow *parentWindow, QWidget *dock, bool newLine=false, const char *name=0, bool honor_style=FALSE, bool readConfig=TRUE)
| Constructor for non-XML-GUI applications.
int | insertButton (const QString &icon, int id, bool enabled=true, const QString &text=QString::null, int index=-1, KInstance *_instance=KGlobal::instance())
| Insert a button (a KToolBarButton) with a pixmap.
int | insertButton (const QString &icon, int id, const char *signal, const QObject *receiver, const char *slot, bool enabled=true, const QString &text=QString::null, int index=-1, KInstance *_instance=KGlobal::instance())
| This is the same as above, but with specified signals and slots to which this button will be connected.
int | insertButton (const QPixmap &pixmap, int id, bool enabled=true, const QString &text=QString::null, int index=-1)
| Inserts a button (a KToolBarButton) with the specified pixmap.
int | insertButton (const QPixmap &pixmap, int id, const char *signal, const QObject *receiver, const char *slot, bool enabled=true, const QString &text=QString::null, int index=-1)
| This is the same as above, but with specified signals and slots to which this button will be connected.
int | insertButton (const QString &icon, int id, QPopupMenu *popup, bool enabled, const QString &_text, int index=-1)
| Inserts a button with popupmenu.
int | insertButton (const QPixmap &pixmap, int id, QPopupMenu *popup, bool enabled, const QString &_text, int index=-1)
| Inserts a button with popupmenu.
int | insertLined (const QString &text, int id, const char *signal, const QObject *receiver, const char *slot, bool enabled=true, const QString &toolTipText=QString::null, int size=70, int index=-1)
| Inserts a KLineEdit.
int | insertCombo (const QStringList &list, int id, bool writable, const char *signal, const QObject *receiver, const char *slot, bool enabled=true, const QString &tooltiptext=QString::null, int size=70, int index=-1, QComboBox::Policy policy=QComboBox::AtBottom)
| Inserts a KComboBox with list.
int | insertCombo (const QString &text, int id, bool writable, const char *signal, QObject *recevier, const char *slot, bool enabled=true, const QString &tooltiptext=QString::null, int size=70, int index=-1, QComboBox::Policy policy=QComboBox::AtBottom)
| Insert a KComboBox with text.
int | insertSeparator (int index=-1, int id=-1)
| Inserts a separator into the toolbar with the given id.
int | insertLineSeparator (int index=-1, int id=-1)
| Inserts a line separator into the toolbar with the given id.
int | insertWidget (int id, int width, QWidget *_widget, int index=-1)
| Inserts a user-defined widget.
int | insertAnimatedWidget (int id, QObject *receiver, const char *slot, const QString &icons, int index=-1)
| Inserts an animated widget.
KAnimWidget * | animatedWidget (int id)
| This will return a pointer to the given animated widget, if it exists.
void | addConnection (int id, const char *signal, const QObject *receiver, const char *slot)
| Adds connections to items.
void | setItemEnabled (int id, bool enabled)
| Enables/disables item.
void | setButtonIcon (int id, const QString &_icon)
| Sets the icon for a button.
void | setButtonPixmap (int id, const QPixmap &_pixmap)
| Sets button pixmap.
void | setButtonIconSet (int id, const QIconSet &iconset)
| Sets a button icon from a QIconSet.
void | setDelayedPopup (int id, QPopupMenu *_popup, bool toggle=false)
| Sets a delayed popup for a button.
void | setAutoRepeat (int id, bool flag=true)
| Turns a button into an autorepeat button.
void | setToggle (int id, bool flag=true)
| Turns button into a toggle button if `flag` is true.
void | toggleButton (int id)
| Toggles a togglebutton.
void | setButton (int id, bool flag)
| Sets a toggle button state.
bool | isButtonOn (int id) const
void | setLinedText (int id, const QString &text)
| Sets the text of a line editor.
QString | getLinedText (int id) const
| Returns a line editor text.
void | insertComboItem (int id, const QString &text, int index)
| Inserts `text` in combobox `id` at position `index`.
void | insertComboList (int id, const QStringList &list, int index)
| Inserts `list` in combobox `id` at position `index`.
void | removeComboItem (int id, int index)
| Removes item `index` from combobox `id`.
void | setCurrentComboItem (int id, int index)
| Sets item `index` to be current item in combobox `id`.
void | changeComboItem (int id, const QString &text, int index=-1)
| Changes item `index` in combobox `id` to text.
void | clearCombo (int id)
| Clears the combobox `id`.
QString | getComboItem (int id, int index=-1) const
| Returns text of item `index` from combobox `id`.
KComboBox * | getCombo (int id)
| Returns a pointer to the combobox.
KLineEdit * | getLined (int id)
| Returns a pointer to KToolBarLined.
KToolBarButton * | getButton (int id)
| Returns a pointer to KToolBarButton.
void | alignItemRight (int id, bool right=true)
| Align item to the right.
QWidget * | getWidget (int id)
| Returns a pointer to an inserted widget.
void | setItemAutoSized (int id, bool yes=true)
| Set item autosized.
void | clear ()
| Remove all items.
void | removeItem (int id)
| Remove item `id`.
void | hideItem (int id)
| Hide item.
void | showItem (int id)
| Show item.
void | setFullSize (bool flag=true)
| Set toolbar to full parent size (default).
bool | fullSize () const
void | enableMoving (bool flag=true)
| This class or method is obsolete, it is provided for compatibility only. use setMovingEnabled(bool) instead.
void | setBarPos (BarPosition bpos)
| Set position of toolbar.
BarPosition | barPos () const
| Returns position of toolbar.
bool | enable (BarStatus stat)
| This class or method is obsolete, it is provided for compatibility only. Show, hide, or toggle toolbar.
void | setMaxHeight (int h)
| This class or method is obsolete, it is provided for compatibility only. Use setMaximumHeight() instead.
int | maxHeight ()
| This class or method is obsolete, it is provided for compatibility only. Use maximumHeight() instead.
void | setMaxWidth (int dw)
| This class or method is obsolete, it is provided for compatibility only. Use setMaximumWidth() instead.
int | maxWidth ()
| This class or method is obsolete, it is provided for compatibility only. Use maximumWidth() instead.
void | setTitle (const QString &_title)
| Set title for toolbar when it floats.
void | enableFloating (bool arrrrrrgh)
| This class or method is obsolete, it is provided for compatibility only. Use enableMoving() instead.
void | setIconText (IconText it)
| Set the kind of painting for buttons.
void | setIconText (IconText it, bool update)
| Similar to setIconText(IconText it) but allows you to disable or enable updating.
IconText | iconText () const
void | setIconSize (int size)
| Set the icon size to load.
void | setIconSize (int size, bool update)
| Same as setIconText(int size) but allows you to disable the toolbar update.
int | iconSize () const
void | setEnableContextMenu (bool enable=true)
| This allows you to enable or disable the context menu.
bool | contextMenuEnabled () const
| Returns whether or not the context menu is disabled.
void | setItemNoStyle (int id, bool no_style=true)
| This will inform a toolbar button to ignore certain style changes.
void | setFlat (bool flag)
int | count () const
void | saveState ()
| Instruct the toolbar to save it's current state to either the app config file or to the XML-GUI resource file (whichever has precedence).
void | saveSettings (KConfig *config, const QString &configGroup)
| Save the toolbar settings to group `configGroup` in `config`.
void | applySettings (KConfig *config, const QString &configGroup)
| Read the toolbar settings from group `configGroup` in `config` and apply them.
void | setXMLGUIClient (KXMLGUIClient *client)
| Tell the toolbar what XML-GUI resource file it should use to save it's state.
void | setText (const QString &txt)
| Assign a (translated) text to this toolbar.
QString | text () const
void | setStretchableWidget (QWidget *w)
QSizePolicy | sizePolicy () const
bool | highlight () const
QSize | sizeHint () const
QSize | minimumSizeHint () const
QSize | minimumSize () const
void | hide ()
void | show ()
void | updateRects (bool=FALSE)
void | loadState (const QDomElement &e)
void | saveState (QDomElement &e)
void | positionYourself (bool force=false)
## Static Public Member Functions
bool | highlightSetting ()
bool | transparentSetting ()
IconText | iconTextSetting ()
## Protected Member Functions
void | mousePressEvent (QMouseEvent *)
void | childEvent (QChildEvent *e)
void | showEvent (QShowEvent *e)
void | resizeEvent (QResizeEvent *e)
bool | event (QEvent *e)
void | applyAppearanceSettings (KConfig *config, const QString &_configGroup, bool forceGlobal=false)
QString | settingsGroup () const
virtual void | virtual_hook (int id, void *data)

## Detailed Description

A KDE-style toolbar. Floatable toolbar with auto resize.

KToolBar can be dragged around in and between different docks.

A KToolBar can contain all sorts of widgets.

KToolBar can be used as a standalone widget, but KMainWindow provides easy factories and management of one or more toolbars. Once you have a KToolBar object, you can insert items into it with the insert... methods, or remove them with the removeItem() method. This can be done at any time; the toolbar will be automatically updated. There are also many methods to set per-child properties like alignment and toggle behaviour.

KToolBar uses a global config group to load toolbar settings on construction. It will reread this config group on a KApplication::appearanceChanged() signal.

Version:
  Id
    ktoolbar.h,v 1.153.2.1 2002/12/09 23:28:37 faure Exp

Author:
  Reginald Stadlbauer <reggie@kde.org>, Stephan Kulow <coolo@kde.org>, Sven Radej <radej@kde.org>.

Definition at line 101 of file ktoolbar.h.

## Member Enumeration Documentation

enum KToolBar::BarStatus

| The state of the status bar. This class or method is obsolete, it is provided for compatibility only. Definition at line 117 of file ktoolbar.h.

enum KToolBar::BarPosition

| Possible bar positions. Definition at line 121 of file ktoolbar.h. Referenced by barPos().

## Constructor & Destructor Documentation

KToolBar::KToolBar | ( | QWidget * | parent,
|  | const char * | name = 0,
|  | bool | honor_style = FALSE,
|  | bool | readConfig = TRUE
| ) |

  | Constructor. This constructor is used by the XML-GUI. If you use it, you need to call QMainWindow::addToolBar to specify the position of the toolbar. So it's simpler to use the other constructor. The toolbar will read in various global config settings for things like icon size and text position, etc. However, some of the settings will be honored only if _honor_mode is set to true. All other toolbars will be IconOnly and use Medium icons. Parameters:
  parent | The standard toolbar parent (usually a KMainWindow)
  name | The standard internal name
  honor_style | If true, then global settings for IconSize and IconText will be honored
  readConfig | whether to apply the configuration (global and application-specific)
Definition at line 170 of file ktoolbar.cpp. References KStdAccel::name().

KToolBar::KToolBar | ( | QMainWindow * | parentWindow,
|  | QMainWindow::ToolBarDock | dock,
|  | bool | newLine = false,
|  | const char * | name = 0,
|  | bool | honor_style = FALSE,
|  | bool | readConfig = TRUE
| ) |

  | Constructor for non-XML-GUI applications. The toolbar will read in various global config settings for things like icon size and text position, etc. However, some of the settings will be honored only if _honor_mode is set to true. All other toolbars will be IconOnly and use Medium icons. Parameters:
  parentWindow | The window that should be the parent of this toolbar
  dock | The position of the toolbar. Usually QMainWindow::Top.
  newLine | If true, start a new line in the dock for this toolbar.
  name | The standard internal name
  honor_style | If true, then global settings for IconSize and IconText will be honored
  readConfig | whether to apply the configuration (global and application-specific)
Definition at line 179 of file ktoolbar.cpp. References KStdAccel::name().

KToolBar::KToolBar | ( | QMainWindow * | parentWindow,
|  | QWidget * | dock,
|  | bool | newLine = false,
|  | const char * | name = 0,
|  | bool | honor_style = FALSE,
|  | bool | readConfig = TRUE
| ) |

  | Constructor for non-XML-GUI applications. The toolbar will read in various global config settings for things like icon size and text position, etc. However, some of the settings will be honored only if _honor_mode is set to true. All other toolbars will be IconOnly and use Medium icons. Parameters:
  parentWindow | The window that should be the parent of this toolbar
  dock | Another widget than the mainwindow to dock toolbar to.
  newLine | If true, start a new line in the dock for this toolbar.
  name | The standard internal name
  honor_style | If true, then global settings for IconSize and IconText will be honored
  readConfig | whether to apply the configuration (global and application-specific)
Definition at line 187 of file ktoolbar.cpp. References KStdAccel::name().

## Member Function Documentation

int KToolBar::insertButton | ( | const QString & | icon,
|  | int | id,
|  | bool | enabled = true,
|  | const QString & | text = QString::null,
|  | int | index = -1,
|  | KInstance * | _instance = KGlobal::instance()
| ) |

  | Insert a button (a KToolBarButton) with a pixmap. The pixmap is loaded by the button itself based on the global icon settings. You should connect to one or more signals in KToolBar: clicked() , pressed() , released() , or highlighted() and if the button is a toggle button (setToggle() ) toggled() . Those signals have `id` of a button that caused the signal. If you want to bind a popup to button, see setButton(). Parameters:
  icon | The name of the icon to use as the active pixmap
  id | The id of this button
  enabled | Enable or disable the button at startup
  text | The tooltip or toolbar text (depending on state)
  index | The position of the button. (-1 = at end).
Returns: The item index. Definition at line 229 of file ktoolbar.cpp. Referenced by KToolBarPopupAction::plug(), KActionMenu::plug(), and KAction::plug().

int KToolBar::insertButton | ( | const QString & | icon,
|  | int | id,
|  | const char * | signal,
|  | const QObject * | receiver,
|  | const char * | slot,
|  | bool | enabled = true,
|  | const QString & | text = QString::null,
|  | int | index = -1,
|  | KInstance * | _instance = KGlobal::instance()
| ) |

  | This is the same as above, but with specified signals and slots to which this button will be connected. You can add more signals with addConnection(). Parameters:
  icon | The name of the icon to use as the active pixmap
  id | The id of this button
  signal | The signal to connect to
  receiver | The slot's parent
  enabled | Enable or disable the button at startup
  text | The tooltip or toolbar text (depending on state)
  index | The position of the button. (-1 = at end).
Returns: The item index. Definition at line 241 of file ktoolbar.cpp.

int KToolBar::insertButton | ( | const QPixmap & | pixmap,
|  | int | id,
|  | bool | enabled = true,
|  | const QString & | text = QString::null,
|  | int | index = -1
| ) |

  | Inserts a button (a KToolBarButton) with the specified pixmap. This pixmap will be used as the "active" one and the disabled and default ones will be autogenerated. It is recommended that you use the insertButton function that allows you to specify the icon name rather then the pixmap itself. Specifying the icon name is much more flexible. You should connect to one or more signals in KToolBar: clicked() , pressed() , released() , or highlighted() and if the button is a toggle button (setToggle() ) toggled() . Those signals have `id` of a button that caused the signal. If you want to bind a popup to button, see setButton(). Parameters:
  pixmap | The active pixmap
  id | The id of this button
  enabled | Enable or disable the button at startup
  text | The tooltip or toolbar text (depending on state)
  index | The position of the button. (-1 = at end).
Returns: The item index. Definition at line 254 of file ktoolbar.cpp.

int KToolBar::insertButton | ( | const QPixmap & | pixmap,
|  | int | id,
|  | const char * | signal,
|  | const QObject * | receiver,
|  | const char * | slot,
|  | bool | enabled = true,
|  | const QString & | text = QString::null,
|  | int | index = -1
| ) |

  | This is the same as above, but with specified signals and slots to which this button will be connected. You can add more signals with addConnection(). Parameters:
  icon | The name of the icon to use as the active pixmap
  id | The id of this button
  signal | The signal to connect to
  receiver | The slot's parent
  enabled | Enable or disable the button at startup
  text | The tooltip or toolbar text (depending on state)
  index | The position of the button. (-1 = at end).
Returns: The item index. Definition at line 265 of file ktoolbar.cpp.

int KToolBar::insertButton | ( | const QString & | icon,
|  | int | id,
|  | QPopupMenu * | popup,
|  | bool | enabled,
|  | const QString & | _text,
|  | int | index = -1
| ) |

| Inserts a button with popupmenu. Button will have small triangle. You have to connect to popup's signals. The signals KButton::pressed(), KButton::released(), KButton::clicked() or KButton::doubleClicked() are `not` emmited by this button (see setDelayedPopup() for that). You can add custom popups which inherit QPopupMenu to get popups with tables, drawings etc. Just don't fiddle with events there. Definition at line 279 of file ktoolbar.cpp. References KToolBarButton::setPopup().

int KToolBar::insertButton | ( | const QPixmap & | pixmap,
|  | int | id,
|  | QPopupMenu * | popup,
|  | bool | enabled,
|  | const QString & | _text,
|  | int | index = -1
| ) |

| Inserts a button with popupmenu. Button will have small triangle. You have to connect to popup's signals. The signals KButton::pressed(), KButton::released(), KButton::clicked() or KButton::doubleClicked() are `not` emmited by this button (see setDelayedPopup() for that). You can add custom popups which inherit QPopupMenu to get popups with tables, drawings etc. Just don't fiddle with events there. Definition at line 291 of file ktoolbar.cpp. References KToolBarButton::setPopup().

int KToolBar::insertLined | ( | const QString & | text,
|  | int | id,
|  | const char * | signal,
|  | const QObject * | receiver,
|  | const char * | slot,
|  | bool | enabled = true,
|  | const QString & | toolTipText = QString::null,
|  | int | size = 70,
|  | int | index = -1
| ) |

| Inserts a KLineEdit. You have to specify signals and slots to which KLineEdit will be connected. KLineEdit has all slots QLineEdit has, plus signals KLineEdit::completion and KLineEdit::textRotation KLineEdit can be set to autoresize itself to full free width in toolbar, that is to last right aligned item. For that, toolbar must be set to full width (which it is by default). See also: setFullWidth() setItemAutoSized() KLineEdit Returns: Item index. Definition at line 303 of file ktoolbar.cpp. References QToolTip::add(), QString::isEmpty(), and QLineEdit::setText().

int KToolBar::insertCombo | ( | const QStringList & | list,
|  | int | id,
|  | bool | writable,
|  | const char * | signal,
|  | const QObject * | receiver,
|  | const char * | slot,
|  | bool | enabled = true,
|  | const QString & | tooltiptext = QString::null,
|  | int | size = 70,
|  | int | index = -1,
|  | QComboBox::Policy | policy = QComboBox::AtBottom
| ) |

| Inserts a KComboBox with list. Can be writable, but cannot contain pixmaps. By default inserting policy is AtBottom, i.e. typed items are placed at the bottom of the list. Can be autosized. If the size argument is specified as -1, the width of the combobox is automatically computed. See also: setFullWidth() setItemAutoSized() KComboBox Returns: Item index. Definition at line 322 of file ktoolbar.cpp. References QToolTip::add(), QComboBox::insertStringList(), QString::isEmpty(), QString::isNull(), and QComboBox::setInsertionPolicy(). Referenced by KSelectAction::plug().

int KToolBar::insertCombo | ( | const QString & | text,
|  | int | id,
|  | bool | writable,
|  | const char * | signal,
|  | QObject * | recevier,
|  | const char * | slot,
|  | bool | enabled = true,
|  | const QString & | tooltiptext = QString::null,
|  | int | size = 70,
|  | int | index = -1,
|  | QComboBox::Policy | policy = QComboBox::AtBottom
| ) |

| Insert a KComboBox with text. The rest is the same as above. See also: setItemAutoSized() KComboBox Returns: Item index. Definition at line 348 of file ktoolbar.cpp. References QToolTip::add(), QComboBox::insertItem(), QString::isEmpty(), QString::isNull(), and QComboBox::setInsertionPolicy().

int KToolBar::insertSeparator | ( | int | index = -1,
|  | int | id = -1
| ) |

| Inserts a separator into the toolbar with the given id. Returns the separator's index Definition at line 370 of file ktoolbar.cpp.

int KToolBar::insertLineSeparator | ( | int | index = -1,
|  | int | id = -1
| ) |

| Inserts a line separator into the toolbar with the given id. Returns the separator's index Definition at line 377 of file ktoolbar.cpp.

int KToolBar::insertWidget | ( | int | id,
|  | int | width,
|  | QWidget * | _widget,
|  | int | index = -1
| ) |

| Inserts a user-defined widget. The widget `must` have this toolbar as its parent. Widget must have a QWidget for base class. Widget can be autosized to full width. If you forget about it, you can get a pointer to this widget with getWidget(). See also: setItemAutoSized() Returns: Item index. Definition at line 385 of file ktoolbar.cpp. Referenced by KWidgetAction::plug().

int KToolBar::insertAnimatedWidget | ( | int | id,
|  | QObject * | receiver,
|  | const char * | slot,
|  | const QString & | icons,
|  | int | index = -1
| ) |

  | Inserts an animated widget. A KAnimWidget will be created internally using the icon name you provide. This will emit a signal (clicked()) whenever the animation widget is clicked. See also: animatedWidget() Parameters:
  id | The id for this toolbar item
  receiver | The parent of your slot
  slot | The slot to receive the clicked() signal
  icons | The name of the animation icon group to use
  index | The item index
Returns: The item index Definition at line 392 of file ktoolbar.cpp. References clicked().

KAnimWidget * KToolBar::animatedWidget | ( | int | id | ) |

  | This will return a pointer to the given animated widget, if it exists. See also: insertAnimatedWidget Parameters:
  id | The id for the widget you want to get a pointer to
Returns: A pointer to the current animated widget or 0L Definition at line 404 of file ktoolbar.cpp. References QMap::end(), QMap::find(), and QObject::inherits().

void KToolBar::addConnection | ( | int | id,
|  | const char * | signal,
|  | const QObject * | receiver,
|  | const char * | slot
| ) |

| Adds connections to items. It is important that you know the `id` of particular item. Nothing happens if you forget `id`. Definition at line 430 of file ktoolbar.cpp. References QMap::end(), and QMap::find().

void KToolBar::setItemEnabled | ( | int | id,
|  | bool | enabled
| ) |

| Enables/disables item. Definition at line 440 of file ktoolbar.cpp. References QMap::end(), and QMap::find().

void KToolBar::setButtonIcon | ( | int | id,
|  | const QString & | _icon
| ) |

| Sets the icon for a button. Can be used while button is visible. Definition at line 461 of file ktoolbar.cpp. References QMap::end(), QMap::find(), and KToolBarButton::setIcon().

void KToolBar::setButtonPixmap | ( | int | id,
|  | const QPixmap & | _pixmap
| ) |

| Sets button pixmap. Can be used while button is visible. Definition at line 450 of file ktoolbar.cpp. References QMap::end(), QMap::find(), and KToolBarButton::setPixmap().

void KToolBar::setButtonIconSet | ( | int | id,
|  | const QIconSet & | iconset
| ) |

| Sets a button icon from a QIconSet. Can be used while button is visible. Definition at line 471 of file ktoolbar.cpp. References QMap::end(), QMap::find(), and KToolBarButton::setIconSet().

void KToolBar::setDelayedPopup | ( | int | id,
|  | QPopupMenu * | _popup,
|  | bool | toggle = false
| ) |

| Sets a delayed popup for a button. Delayed popup is what you see in Netscape Navigator's Previous and Next buttons: If you click them you go back or forth. If you press them long enough, you get a history-menu. This is exactly what we do here. You will insert normal a button with connection (or use signals from toolbar):
     bar->insertButton(icon, id, SIGNAL(clicked ()), this,
                       SLOT (slotClick()), true, "click or wait for popup");

And then add a delayed popup:

     bar->setDelayedPopup (id, historyPopup);

Don't add delayed popups to buttons which have normal popups.

You may add popups which are derived from QPopupMenu. You may add popups that are already in the menu bar or are submenus of other popups.

Definition at line 482 of file ktoolbar.cpp.

References QMap::end(), QMap::find(), and KToolBarButton::setDelayedPopup().

Referenced by KToolBarPopupAction::plug(), and KActionMenu::plug().

void KToolBar::setAutoRepeat | ( | int | id,
|  | bool | flag = true
| ) |

| Turns a button into an autorepeat button. Toggle buttons, buttons with menus, or buttons with delayed menus cannot be made into autorepeat buttons. Moreover, you can and will receive only the signal clicked(), but not pressed() or released(). When the user presses this button, you will receive the signal clicked(), and if the button is still pressed after some time, you will receive more clicked() signals separated by regular intervals. Since this uses QButton::setAutoRepeat() , I can't quantify 'some'. Definition at line 493 of file ktoolbar.cpp. References QMap::end(), and QMap::find().

void KToolBar::setToggle | ( | int | id,
|  | bool | flag = true
| ) |

| Turns button into a toggle button if `flag` is true. Definition at line 504 of file ktoolbar.cpp. References QMap::end(), QMap::find(), and KToolBarButton::setToggle(). Referenced by KToggleAction::plug().

void KToolBar::toggleButton | ( | int | id | ) |

| Toggles a togglebutton. If the button is a toggle button (see setToggle()) the button state will be toggled. This will also cause the toolbar to emit the signal KButton::toggled() with parameter `id`. You must connect to this signal, or use addConnection() to connect directly to the button signal KButton::toggled(). Definition at line 515 of file ktoolbar.cpp. References QMap::end(), QMap::find(), and KToolBarButton::toggle().

void KToolBar::setButton | ( | int | id,
|  | bool | flag
| ) |

| Sets a toggle button state. If the button is a toggle button (see setToggle()) this will set its state flag. This will also emit the signal KButton::toggled(). See also: setToggle() Definition at line 526 of file ktoolbar.cpp. References QMap::end(), QMap::find(), and KToolBarButton::on(). Referenced by KToggleAction::plug().

bool KToolBar::isButtonOn | ( | int | id | ) | const

| Returns: `true` if button is on, `false` if button is off or if the button is not a toggle button. See also: setToggle() Definition at line 537 of file ktoolbar.cpp. References QMap::end(), and QMap::find().

void KToolBar::setLinedText | ( | int | id,
|  | const QString & | text
| ) |

| Sets the text of a line editor. Cursor is set at end of text. Definition at line 547 of file ktoolbar.cpp. References QMap::end(), QMap::find(), and QLineEdit::setText().

QString KToolBar::getLinedText | ( | int | id | ) | const

| Returns a line editor text. Definition at line 558 of file ktoolbar.cpp. References QMap::end(), QMap::find(), and QLineEdit::text().

void KToolBar::insertComboItem | ( | int | id,
|  | const QString & | text,
|  | int | index
| ) |

| Inserts `text` in combobox `id` at position `index`. Definition at line 568 of file ktoolbar.cpp. References QMap::end(), QMap::find(), and QComboBox::insertItem().

void KToolBar::insertComboList | ( | int | id,
|  | const QStringList & | list,
|  | int | index
| ) |

| Inserts `list` in combobox `id` at position `index`. Definition at line 578 of file ktoolbar.cpp. References QMap::end(), QMap::find(), and QComboBox::insertStringList().

void KToolBar::removeComboItem | ( | int | id,
|  | int | index
| ) |

| Removes item `index` from combobox `id`. Definition at line 589 of file ktoolbar.cpp. References QMap::end(), QMap::find(), and QComboBox::removeItem().

void KToolBar::setCurrentComboItem | ( | int | id,
|  | int | index
| ) |

| Sets item `index` to be current item in combobox `id`. Definition at line 600 of file ktoolbar.cpp. References QMap::end(), QMap::find(), and QComboBox::setCurrentItem().

void KToolBar::changeComboItem | ( | int | id,
|  | const QString & | text,
|  | int | index = -1
| ) |

| Changes item `index` in combobox `id` to text. `index` = -1 refers current item (one displayed in the button). Definition at line 611 of file ktoolbar.cpp. References QComboBox::changeItem(), QMap::end(), and QMap::find().

void KToolBar::clearCombo | ( | int | id | ) |

| Clears the combobox `id`. Does not delete it or hide it. Definition at line 622 of file ktoolbar.cpp. References QComboBox::clear(), QMap::end(), and QMap::find().

QString KToolBar::getComboItem | ( | int | id,
|  | int | index = -1
| ) | const

| Returns text of item `index` from combobox `id`. `index` = -1 refers to current item. Definition at line 633 of file ktoolbar.cpp. References QMap::end(), QMap::find(), and QComboBox::text().

KComboBox * KToolBar::getCombo | ( | int | id | ) |

| Returns a pointer to the combobox. Example:
     KComboBox *combo = toolbar->getCombo(combo_id);
That way you can get access to other public methods that KComboBox provides. Definition at line 643 of file ktoolbar.cpp. References QMap::end(), and QMap::find(). Referenced by KSelectAction::plug().

KLineEdit * KToolBar::getLined | ( | int | id | ) |

| Returns a pointer to KToolBarLined. Example:
     KLineEdit * lined = toolbar->getKTollBarLined(lined_id);
That way you can get access to other public methods that KLineEdit provides. KLineEdit is the same thing as QLineEdit plus completion signals. Definition at line 652 of file ktoolbar.cpp. References QMap::end(), and QMap::find().

KToolBarButton * KToolBar::getButton | ( | int | id | ) |

| Returns a pointer to KToolBarButton. Example:
     KToolBarButton * button = toolbar->getButton(button_id);
That way you can get access to other public methods that KToolBarButton provides. Using this method is not recommended. Definition at line 661 of file ktoolbar.cpp. References QMap::end(), and QMap::find(). Referenced by KToolBarRadioGroup::addButton(), KToolBarPopupAction::plug(), KActionMenu::plug(), and KAction::plug().

void KToolBar::alignItemRight | ( | int | id,
|  | bool | right = true
| ) |

| Align item to the right. This works only if toolbar is set to full width. See also: setFullWidth() Definition at line 670 of file ktoolbar.cpp. References QMap::end(), and QMap::find().

QWidget * KToolBar::getWidget | ( | int | id | ) |

| Returns a pointer to an inserted widget. Wrong ids are not tested. You can do with this whatever you want, except change its height (hardcoded). If you change its width you will probably have to call QToolBar::updateRects(true) See also: QWidget updateRects() Definition at line 682 of file ktoolbar.cpp. References QMap::end(), and QMap::find(). Referenced by hideItem(), setItemAutoSized(), and showItem().

void KToolBar::setItemAutoSized | ( | int | id,
|  | bool | yes = true
| ) |

| Set item autosized. This works only if the toolbar is set to full width. Only `one` item can be autosized, and it has to be the last left-aligned item. Items that come after this must be right aligned. Items that can be right aligned are Lineds, Frames, Widgets and Combos. An autosized item will resize itself whenever the toolbar geometry changes to the last right-aligned item (or to end of toolbar if there are no right-aligned items.) See also: setFullWidth() alignItemRight() Definition at line 689 of file ktoolbar.cpp. References getWidget(), and QToolBar::setStretchableWidget(). Referenced by KWidgetAction::plug().

void KToolBar::clear | ( |  | ) |

| Remove all items. The toolbar is redrawn after it. Reimplemented from QToolBar. Definition at line 697 of file ktoolbar.cpp. References QMap::clear(), QMap< QWidget *, int >::clear(), and QToolBar::clear().

void KToolBar::removeItem | ( | int | id | ) |

| Remove item `id`. Item is deleted. Toolbar is redrawn after it. Definition at line 705 of file ktoolbar.cpp. References QMap::end(), QMap::find(), QMap< QWidget *, int >::remove(), QMap::remove(), and QPtrList< QWidget >::removeRef(). Referenced by KAction::unplug().

void KToolBar::hideItem | ( | int | id | ) |

| Hide item. Definition at line 721 of file ktoolbar.cpp. References getWidget(), and QWidget::hide().

void KToolBar::showItem | ( | int | id | ) |

| Show item. Definition at line 729 of file ktoolbar.cpp. References getWidget(), and QWidget::show().

void KToolBar::setFullSize | ( | bool | flag = true | ) |

| Set toolbar to full parent size (default). In full size mode the bar extends over the parent's full width or height. If the mode is disabled the toolbar tries to take as much space as it needs without wrapping, but it does not exceed the parent box. You can force a certain width or height with setMaxWidth() or setMaxHeight(). If you want to use right-aligned items or auto-sized items you must use full size mode. Definition at line 737 of file ktoolbar.cpp.

bool KToolBar::fullSize | ( |  | ) | const

| Returns: `true` if the full-size mode is enabled. Otherwise it returns . Definition at line 744 of file ktoolbar.cpp.

void KToolBar::enableMoving | ( | bool | flag = true | ) |

| This class or method is obsolete, it is provided for compatibility only. use setMovingEnabled(bool) instead. Enable or disable moving of toolbar. Definition at line 750 of file ktoolbar.cpp.

void KToolBar::setBarPos | ( | BarPosition | bpos | ) |

| Set position of toolbar. See also: BarPosition() Definition at line 756 of file ktoolbar.cpp. References QToolBar::mainWindow().

KToolBar::BarPosition KToolBar::barPos | ( |  | ) | const

| Returns position of toolbar. Definition at line 764 of file ktoolbar.cpp. References BarPosition, and QToolBar::mainWindow(). Referenced by KMainWindow::sizeForCentralWidgetSize().

bool KToolBar::enable | ( | BarStatus | stat | ) |

| This class or method is obsolete, it is provided for compatibility only. Show, hide, or toggle toolbar. This method is provided for compatibility only, please use show() and/or hide() instead. See also: BarStatus Definition at line 779 of file ktoolbar.cpp. References KIO::stat().

void KToolBar::setMaxHeight | ( | int | h | ) |

| This class or method is obsolete, it is provided for compatibility only. Use setMaximumHeight() instead. Definition at line 792 of file ktoolbar.cpp.

int KToolBar::maxHeight | ( |  | ) |

| This class or method is obsolete, it is provided for compatibility only. Use maximumHeight() instead. Returns the value that was set with setMaxHeight(). Definition at line 797 of file ktoolbar.cpp.

void KToolBar::setMaxWidth | ( | int | dw | ) |

| This class or method is obsolete, it is provided for compatibility only. Use setMaximumWidth() instead. Set maximal width of horizontal (top or bottom) toolbar. Definition at line 803 of file ktoolbar.cpp.

int KToolBar::maxWidth | ( |  | ) |

| This class or method is obsolete, it is provided for compatibility only. Use maximumWidth() instead. Returns the value that was set with setMaxWidth(). Definition at line 809 of file ktoolbar.cpp.

void KToolBar::setTitle | ( | const QString & | _title | ) |

| Set title for toolbar when it floats. Titles are however not (yet) visible. You can't change toolbar's title while it's floating. Definition at line 815 of file ktoolbar.cpp. References QToolBar::setLabel().

void KToolBar::enableFloating | ( | bool | arrrrrrgh | ) |

| This class or method is obsolete, it is provided for compatibility only. Use enableMoving() instead. Definition at line 821 of file ktoolbar.cpp.

void KToolBar::setIconText | ( | IconText | it | ) |

| Set the kind of painting for buttons. Choose from: IconOnly (only icons), IconTextRight (icon and text, text is left from icons), TextOnly (only text), IconTextBottom (icons and text, text is under icons). See also: IconText Definition at line 826 of file ktoolbar.cpp.

void KToolBar::setIconText | ( | IconText | it,
|  | bool | update
| ) |

| Similar to setIconText(IconText it) but allows you to disable or enable updating. If `update` is false, then the buttons will not be updated. This is useful only if you know that you will be forcing an update later. Definition at line 832 of file ktoolbar.cpp. References QToolBar::mainWindow().

KToolBar::IconText KToolBar::iconText | ( |  | ) | const

| Returns: The current text style for buttons. Definition at line 858 of file ktoolbar.cpp.

void KToolBar::setIconSize | ( | int | size | ) |

  | Set the icon size to load. Usually you should not call this, the icon size is taken care of by KIconLoader and globally configured. By default, the toolbar will load icons of size 32 for main toolbars and 22 for other toolbars See also: KIconLoader. Parameters:
  size | The size to use
Definition at line 864 of file ktoolbar.cpp.

void KToolBar::setIconSize | ( | int | size,
|  | bool | update
| ) |

  | Same as setIconText(int size) but allows you to disable the toolbar update. Parameters:
  size | The size to use
  update | If true, then the toolbar will be updated after this
Definition at line 869 of file ktoolbar.cpp. References QToolBar::mainWindow().

int KToolBar::iconSize | ( |  | ) | const

| Returns: The current icon size for buttons. Definition at line 895 of file ktoolbar.cpp. References KIconLoader::currentSize(), KGlobal::iconLoader(), and QObject::name(). Referenced by saveSettings().

void KToolBar::setEnableContextMenu | ( | bool | enable = true | ) |

  | This allows you to enable or disable the context menu. Parameters:
  enable | If false, then the context menu will be disabled
Definition at line 908 of file ktoolbar.cpp.

bool KToolBar::contextMenuEnabled | ( |  | ) | const

| Returns whether or not the context menu is disabled. Returns: The context menu state Definition at line 914 of file ktoolbar.cpp.

void KToolBar::setItemNoStyle | ( | int | id,
|  | bool | no_style = true
| ) |

  | This will inform a toolbar button to ignore certain style changes. Specifically, it will ignore IconText (always IconOnly) and will not allow image effects to apply. Parameters:
  id | The button to exclude from styles
  no_style | If true, then it is excluded (default: true).
Definition at line 920 of file ktoolbar.cpp. References QMap::end(), QMap::find(), and KToolBarButton::setNoStyle().

int KToolBar::count | ( |  | ) | const

| Returns: the number of items in the toolbar Definition at line 945 of file ktoolbar.cpp. References QMap::count().

void KToolBar::saveState | ( |  | ) |

| Instruct the toolbar to save it's current state to either the app config file or to the XML-GUI resource file (whichever has precedence). Definition at line 951 of file ktoolbar.cpp. References QDomElement::attribute(), KGlobal::config(), QDomDocument::documentElement(), KStdAccel::name(), KXMLGUIFactory::removeDOMComments(), saveSettings(), QDomDocument::setContent(), KConfigBase::sync(), and QDomElement::tagName(). Referenced by KXMLGUIBuilder::removeContainer().

void KToolBar::saveSettings | ( | KConfig * | config,
|  | const QString & | configGroup
| ) |

| Save the toolbar settings to group `configGroup` in `config`. Definition at line 1034 of file ktoolbar.cpp. References iconSize(), QString::isEmpty(), and KConfigBase::writeEntry(). Referenced by KMainWindow::saveMainWindowSettings(), and saveState().

void KToolBar::applySettings | ( | KConfig * | config,
|  | const QString & | configGroup
| ) |

| Read the toolbar settings from group `configGroup` in `config` and apply them. Definition at line 1515 of file ktoolbar.cpp. References KConfigBase::hasGroup(), QString::isEmpty(), QString::lower(), QToolBar::mainWindow(), QMainWindow::moveDockWindow(), KConfigBase::readBoolEntry(), KConfigBase::readEntry(), KConfigBase::readNumEntry(), and KGlobal::staticQString(). Referenced by KMainWindow::applyMainWindowSettings().

void KToolBar::setXMLGUIClient | ( | KXMLGUIClient * | client | ) |

  | Tell the toolbar what XML-GUI resource file it should use to save it's state. The state of the toolbar (position, size, etc) is saved in KConfig files if the application does not use XML-GUI.. but if the app does, then it's saved the XML file. This function allows this to happen. Parameters:
  xmlfile | The XML-GUI resource file to write to
  xml | The DOM document for the XML-GUI building
Definition at line 1062 of file ktoolbar.cpp. Referenced by KXMLGUIBuilder::createContainer().

void KToolBar::setText | ( | const QString & | txt | ) |

| Assign a (translated) text to this toolbar. This is used for the tooltip on the handle, and when listing the toolbars. Definition at line 1067 of file ktoolbar.cpp. References QToolBar::setLabel().

QString KToolBar::text | ( |  | ) | const

| Returns: the toolbar's text. Definition at line 1073 of file ktoolbar.cpp. References QToolBar::label().

void KToolBar::clicked | ( | int | id | ) | `[signal]`

| Emitted when button `id` is clicked. Referenced by insertAnimatedWidget().

void KToolBar::doubleClicked | ( | int | id | ) | `[signal]`

| Emitted when button `id` is double-clicked. Note: you will always recive two clicked() , pressed() and released() signals. There is no way to avoid it - at least no easy way. If you need to resolve this all you can do is set up timers which wait for QApplication::doubleClickInterval() to expire. If in that time you don't get this signal, you may belive that button was only clicked and not double-clicked. And please note that butons with popup menus do not emit this signal, but those with delayed popup do.

void KToolBar::pressed | ( | int |  | ) | `[signal]`

| Emitted when button `id` is pressed.

void KToolBar::released | ( | int |  | ) | `[signal]`

| Emits when button `id` is released.

void KToolBar::toggled | ( | int |  | ) | `[signal]`

| Emitted when a toggle button changes state. Emitted also if you change state with setButton() or toggleButton() If you make a button normal again, with setToggle(false), this signal won't be emitted.

void KToolBar::highlighted | ( | int | id,
|  | bool | isHighlighted
| ) | `[signal]`

| This signal is emitted when item id gets highlighted/unhighlighted (i.e when mouse enters/exits). Note that this signal is emitted from all buttons (normal, disabled and toggle) even when there is no visible change in buttons (i.e., buttons do not raise when mouse enters). The parameter `isHighlighted` is `true` when mouse enters and `false` when mouse exits.

void KToolBar::highlighted | ( | int | id | ) | `[signal]`

| This signal is emitted when item id gets highlighted/unhighlighted (i.e when mouse enters/exits). Note that this signal is emitted from all buttons (normal, disabled and toggle) even when there is no visible change in buttons (i.e., buttons do not raise when mouse enters).

void KToolBar::moved | ( | BarPosition |  | ) | `[signal]`

| Emitted when toolbar changes position, or when an item is removed from toolbar. If you subclass KMainWindow and reimplement KMainWindow::resizeEvent() be sure to connect to this signal. Note: You can connect this signal to a slot that doesn't take parameter.

void KToolBar::toolbarDestroyed | ( |  | ) | `[signal]`

| This signal is emitted when the toolbar is getting deleted, and before ~KToolbar finishes (so it's still time to remove widgets from the toolbar). Used by KWidgetAction. Since: 3.2

bool KToolBar::highlightSetting | ( |  | ) | `[static]`

| Returns: global setting for "Highlight buttons under mouse" Definition at line 1378 of file ktoolbar.cpp. References KGlobal::config(), QString::fromLatin1(), and KConfigBase::readBoolEntry().

bool KToolBar::transparentSetting | ( |  | ) | `[static]`

| Returns: global setting for "Toolbars transparent when moving" Definition at line 1386 of file ktoolbar.cpp. References KGlobal::config(), QString::fromLatin1(), and KConfigBase::readBoolEntry().

KToolBar::IconText KToolBar::iconTextSetting | ( |  | ) | `[static]`

| Returns: global setting for "Icon Text" Definition at line 1394 of file ktoolbar.cpp. References KGlobal::config(), QString::fromLatin1(), and KConfigBase::readEntry().

The documentation for this class was generated from the following files:

- ktoolbar.h
- ktoolbar.cpp

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 13:05:05 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001